unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

// J[\̑ȉ~ϕ RC
//
// ---------------- RC ---------------------------------------------------------
function RC(x, y: double): double;
label
  Ext;
const
//  r  = 1E-24;
  Qc = 872;           // power(3 * r, -1 / 8) = 871.68554
  c1 = 3 / 10;
  c2 = 1 / 7;
  c3 = 3 / 8;
  c4 = 9 / 22;
  c5 = 159 / 208;
  c6 = 9 / 8;
var
  xt, yt, w, yb : double;
  lamda, A0, Q  : double;
  s, Am, Qm     : double;
  m             : integer;
begin
  if y = 0 then begin
    m := 0;
    result := 0;
    goto Ext;
  end;

  if y > 0 then begin
    xt := x;
    yt := y;
    w  := 1;
  end
  else begin
    xt := x - y;
    yt := - y;
    w := sqrt(x / xt);
  end;
  yb := yt;
  A0 := (xt + yt + yt) / 3;
  Am := A0;
  Q := Qc * abs(A0 - xt);
//  Q := power(3 * r, -1 / 8) * abs(A0 - xt);
  m := 0;
  Qm := 1;
  repeat
    lamda := 2 * sqrt(xt) * sqrt(yt) + yt;
    xt := (xt + lamda) / 4;
    yt := (yt + lamda) / 4;
    Am := (Am + lamda) / 4;
    m := m + 1;
    Qm := Qm / 4;
  until (Qm * Q < abs(Am)) or (m > 100);
  s := (yb - A0) * Qm / Am;
//  s := (yb - A0) / power(4, m) / Am;
  result := w * (1 + s * s * (c1 + s * (c2 + s * (c3 + s * (c4 + s * (c5 + s * c6)))))) / sqrt(Am);

Ext:
  Form1.Memo1.Lines.Append('RC Loop = ' + intTostr(m));
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  x, y  : double;
  ans   : double;
  ch    : integer;
  CF    : boolean;
begin
  val(Labelededit1.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(Labelededit2.Text, y, ch);
  if ch <> 0 then begin
    application.MessageBox('y̒lɊԈႢ܂B','',0);
    exit;
  end;
  if y = 0 then begin
    application.MessageBox('y̒l0([)ł͂܂B','',0);
    exit;
  end;
  ans := 0;
  memo1.Clear;
  CF := True;
  case radioGroup1.ItemIndex of
    0:  begin
          memo1.Lines.Append(' x>0 & y>0');
          if (x <= 0) or (y <= 0) then CF := False;
        end;
    1:  memo1.Lines.Append(' -<x<');
    2:  begin
          memo1.Lines.Append(' abs(x)<abs(y)');
          if abs(x) >= abs(y) then CF := False;
        end;
    3:  begin
          memo1.Lines.Append(' abs(x)abs(y)');
          if abs(x) > abs(y) then CF := False;
        end;
    4:  memo1.Lines.Append(' -<x<');
    5:  begin
          memo1.Lines.Append(' abs(x)abs(y)');
          if abs(x) > abs(y) then CF := False;
        end;
    6:  begin
          memo1.Lines.Append(' abs(x)abs(y)');
          if abs(x) < abs(y) then CF := False;
        end;
  end;
  if not CF then begin
    memo1.Lines.Append('͈͊OłB');
    exit;
  end;
  if y < 0 then begin
    y := -y;
    x := -x;
  end;
  case radioGroup1.ItemIndex of
    0:  ans := (x - y) * RC((x + y) * (x + y) / 4, x * y);
    1:  ans := x * RC(y * y, y * y + x * x);
    2:  ans := x * RC(y * y, y * y - x * x);
    3:  ans := x * RC(y * y - x * x, y * y);
    4:  ans := x * RC(y * y + x * x, y * y);
    5:  ans := sqrt(y * y - x * x) * RC(x * x, y * y);
    6:  ans := sqrt(x * x - y * y) * RC(x * x, y * y);
  end;
  memo1.Lines.Append(floatTostr(ans));
end;

end.
